/***************************************************************************
                          display.cpp  -  description
                             -------------------
    begin                : Sun Nov 11 2001
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpainter.h>
#include <qbitmap.h>

#include "general.h"
#include "panelswindow.h"
#include "panel.h"


Panel::Panel(QWidget *parent, const QString &name) : QFrame(/* parent */ /* ,name */)
{
  Q_UNUSED(parent);

   setObjectName (name);
   
 //resize(64,64);

   meterTypes = MeterTypes::None;
   
   updateFrame();
  
 installEventFilter(this);

// setParent(parent);
// show();
}

Panel::~Panel()
{
}

/***************************************************************************
    resize panel
 ***************************************************************************/

void Panel::resizePanel ( int newMeterWidth, int newMeterHeight )
{
    resize ( newMeterWidth, newMeterHeight );
}

void Panel::updateFrame()
{
   setGroupConf ( qsFL1( "ShowWidget" ) );
   panelSolid = getEntryConf ( qsFL1( "panelSolid" ), false, ksensorsSetting::AutoDefault );
   panelOpacityValue = getEntryConf ( qsFL1( "panelOpacityValue" ), -1.0, ksensorsSetting::AutoDefault );
   
   setFrameStyle( ( panelSolid ? ( QFrame::Panel|QFrame::Raised ) : QFrame::NoFrame ) );
   
//   setAutoFillBackground( !panelSolid );
}

// Maybe another better solution to capture childs of child widgets events ???

bool Panel::eventFilter( QObject *o , QEvent *e)
{
  Q_UNUSED(o);

    Q_EMIT eventReceived(e);
 return false;
}

void Panel::paintEvent( QPaintEvent *e )
{
   Q_UNUSED(e);

//    if ( qsShowType != qsFL1( "chart" ) )
    {
   
   QPainter p( this );   
   QRect qrRect;
   QColor qcRectColor;

   qrRect = rect();
   qrRect.adjust( 0, 0, -1, -1 );   
   qcRectColor = palette().color( QPalette::Window );
   qcRectColor.setAlphaF( ( panelOpacityValue / 100.0 ) );
   
//   p.setRenderHint ( QPainter::Antialiasing );
   p.setPen( palette().color( QPalette::Window ) );
   p.setBrush( qcRectColor );

   if ( panelSolid )
      p.drawRect( qrRect );
   else
      p.drawRoundedRect( qrRect, 45.0, 45.0 );

    }

    QFrame::paintEvent( e ); 
}
